/**
 * Copyright (c) 2021, 2024 Contributors to the Eclipse Foundation
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * generated by Xtext 2.22.0
 */
package org.eclipse.trace4cps.tl.etl;

import org.eclipse.emf.ecore.EFactory;

/**
 * <!-- begin-user-doc -->
 * The <b>Factory</b> for the model.
 * It provides a create method for each non-abstract class of the model.
 * <!-- end-user-doc -->
 * @see org.eclipse.trace4cps.tl.etl.EtlPackage
 * @generated
 */
public interface EtlFactory extends EFactory
{
  /**
   * The singleton instance of the factory.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  EtlFactory eINSTANCE = org.eclipse.trace4cps.tl.etl.impl.EtlFactoryImpl.init();

  /**
   * Returns a new object of class '<em>Model</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Model</em>'.
   * @generated
   */
  EtlModel createEtlModel();

  /**
   * Returns a new object of class '<em>Top Level Model Element</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Top Level Model Element</em>'.
   * @generated
   */
  TopLevelModelElement createTopLevelModelElement();

  /**
   * Returns a new object of class '<em>Signal</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Signal</em>'.
   * @generated
   */
  Signal createSignal();

  /**
   * Returns a new object of class '<em>Conv Spec</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Conv Spec</em>'.
   * @generated
   */
  ConvSpec createConvSpec();

  /**
   * Returns a new object of class '<em>Formula</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Formula</em>'.
   * @generated
   */
  Formula createFormula();

  /**
   * Returns a new object of class '<em>Stl Ap</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Stl Ap</em>'.
   * @generated
   */
  StlAp createStlAp();

  /**
   * Returns a new object of class '<em>Mtl Ap</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Mtl Ap</em>'.
   * @generated
   */
  MtlAp createMtlAp();

  /**
   * Returns a new object of class '<em>Attribute Filter</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Attribute Filter</em>'.
   * @generated
   */
  AttributeFilter createAttributeFilter();

  /**
   * Returns a new object of class '<em>Key Val</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Key Val</em>'.
   * @generated
   */
  KeyVal createKeyVal();

  /**
   * Returns a new object of class '<em>Id String</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Id String</em>'.
   * @generated
   */
  IdString createIdString();

  /**
   * Returns a new object of class '<em>Interval</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Interval</em>'.
   * @generated
   */
  Interval createInterval();

  /**
   * Returns a new object of class '<em>Interval SS</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Interval SS</em>'.
   * @generated
   */
  IntervalSS createIntervalSS();

  /**
   * Returns a new object of class '<em>Interval SN</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Interval SN</em>'.
   * @generated
   */
  IntervalSN createIntervalSN();

  /**
   * Returns a new object of class '<em>Interval NS</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Interval NS</em>'.
   * @generated
   */
  IntervalNS createIntervalNS();

  /**
   * Returns a new object of class '<em>Interval NN</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Interval NN</em>'.
   * @generated
   */
  IntervalNN createIntervalNN();

  /**
   * Returns a new object of class '<em>Signal Def</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Signal Def</em>'.
   * @generated
   */
  SignalDef createSignalDef();

  /**
   * Returns a new object of class '<em>Def</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Def</em>'.
   * @generated
   */
  Def createDef();

  /**
   * Returns a new object of class '<em>Check</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Check</em>'.
   * @generated
   */
  Check createCheck();

  /**
   * Returns a new object of class '<em>Trace Signal</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Trace Signal</em>'.
   * @generated
   */
  TraceSignal createTraceSignal();

  /**
   * Returns a new object of class '<em>Throughput Signal</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Throughput Signal</em>'.
   * @generated
   */
  ThroughputSignal createThroughputSignal();

  /**
   * Returns a new object of class '<em>Latency Signal</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Latency Signal</em>'.
   * @generated
   */
  LatencySignal createLatencySignal();

  /**
   * Returns a new object of class '<em>Wip Signal</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Wip Signal</em>'.
   * @generated
   */
  WipSignal createWipSignal();

  /**
   * Returns a new object of class '<em>Resource Amount Signal</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Resource Amount Signal</em>'.
   * @generated
   */
  ResourceAmountSignal createResourceAmountSignal();

  /**
   * Returns a new object of class '<em>Resource Client Signal</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Resource Client Signal</em>'.
   * @generated
   */
  ResourceClientSignal createResourceClientSignal();

  /**
   * Returns a new object of class '<em>Reference Formula</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Reference Formula</em>'.
   * @generated
   */
  ReferenceFormula createReferenceFormula();

  /**
   * Returns a new object of class '<em>Ap Formula</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Ap Formula</em>'.
   * @generated
   */
  ApFormula createApFormula();

  /**
   * Returns a new object of class '<em>Not Formula</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Not Formula</em>'.
   * @generated
   */
  NotFormula createNotFormula();

  /**
   * Returns a new object of class '<em>And Or Formula</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>And Or Formula</em>'.
   * @generated
   */
  AndOrFormula createAndOrFormula();

  /**
   * Returns a new object of class '<em>If Then Formula</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>If Then Formula</em>'.
   * @generated
   */
  IfThenFormula createIfThenFormula();

  /**
   * Returns a new object of class '<em>Globally Untimed Formula</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Globally Untimed Formula</em>'.
   * @generated
   */
  GloballyUntimedFormula createGloballyUntimedFormula();

  /**
   * Returns a new object of class '<em>Globally Formula</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Globally Formula</em>'.
   * @generated
   */
  GloballyFormula createGloballyFormula();

  /**
   * Returns a new object of class '<em>Finally Untimed Formula</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Finally Untimed Formula</em>'.
   * @generated
   */
  FinallyUntimedFormula createFinallyUntimedFormula();

  /**
   * Returns a new object of class '<em>Finally Formula</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Finally Formula</em>'.
   * @generated
   */
  FinallyFormula createFinallyFormula();

  /**
   * Returns a new object of class '<em>Until Untimed Formula</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Until Untimed Formula</em>'.
   * @generated
   */
  UntilUntimedFormula createUntilUntimedFormula();

  /**
   * Returns a new object of class '<em>Until Formula</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Until Formula</em>'.
   * @generated
   */
  UntilFormula createUntilFormula();

  /**
   * Returns a new object of class '<em>Stl Ap Deriv</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Stl Ap Deriv</em>'.
   * @generated
   */
  StlApDeriv createStlApDeriv();

  /**
   * Returns a new object of class '<em>Mtl Ap Start</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Mtl Ap Start</em>'.
   * @generated
   */
  MtlApStart createMtlApStart();

  /**
   * Returns a new object of class '<em>Mtl Ap End</em>'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return a new object of class '<em>Mtl Ap End</em>'.
   * @generated
   */
  MtlApEnd createMtlApEnd();

  /**
   * Returns the package supported by this factory.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the package supported by this factory.
   * @generated
   */
  EtlPackage getEtlPackage();

} //EtlFactory
